pipeline {
	agent any
    environment {
        VERSION = 'Eureka-${BUILD_NUMBER}'
    }
    stages {
        stage ('Clean workspace') {
            steps {
                sh 'git clean -xffd'
            }
        }


        stage('Build du Projet') { 
		 agent {docker 'maven:3.8.3-openjdk-17'}
            steps {
			
                sh 'mvn clean install -DskipTests ' 
				stash includes: 'target/*.jar', name: 'targetfiles'
				
            }
        }

        
        // Sonarqube Analyse 
        stage('Sonarqube analysis ') {
        tools
         {
            maven 'maven'  
         }     
          steps {
            withSonarQubeEnv(installationName:'sonar') {
              sh ''' mvn sonar:sonar'''
            }
          }
        }


        //Build and Upload Image Docker
        stage('Build and Upload Image docker') {
            steps { 
                unstash 'targetfiles'
			   
			   script {
			            sh 'docker login -u mrw1234 -p sesame123' 
						sh 'docker build -t eureka .'
                        sh 'docker tag eureka mrw1234/eureka'
                        sh 'docker push mrw1234/eureka'
                    }
            }
        }

         // nexus
        stage('Nexus') {
           
            steps {
                unstash 'targetfiles'
                nexusArtifactUploader artifacts: [[artifactId: 'Eureka', classifier: '', file: 'target/eurekaMC-0.0.1-SNAPSHOT.jar', type: 'jar']], credentialsId: 'nexus_credentials', groupId: 'backend', nexusUrl: '192.168.115.130:8081', nexusVersion: 'nexus3', protocol: 'http', repository: 'Eureka/',version: VERSION
            }
        }


        stage('Apply Kubernetes File') {
        steps {
          withKubeCredentials(kubectlCredentials: [[caCertificate: '', clusterName: 'default', contextName: '', credentialsId: 'kubernetes', namespace: 'default', serverUrl: 'https://192.168.115.130:6443']]) 

         {
               sh 'curl -LO "https://storage.googleapis.com/kubernetes-release/release/v1.20.5/bin/linux/amd64/kubectl"'
               sh 'chmod u+x ./kubectl'
               sh './kubectl apply -f deploy.yml'
               echo 'service ok'
         }
            }
  } 


    
}
}
		


